
/**
 * \file SimPlayer.h
 * \date 11.03.2003
 * \author Pavol Misik
 * Interface for the SimPlayer class.
 */

#ifndef PLAYER_WORLD_SIM_PLAYER_H
#define PLAYER_WORLD_SIM_PLAYER_H

#include "Player/World/Player.h"
#include "Player/World/Ball.h"

class SimPlayer : public Player  
{
public:
	void PredictNextPos(float dash);
	void Reset();
	int PredictStepsToBall(BALLARRAY& ballVector);
	SimPlayer(World* w);
	SimPlayer(const SimPlayer&);
	virtual SimPlayer& operator=(const SimPlayer&);
	virtual ~SimPlayer();

	float GetEffort()const;
	float GetStamina() const;

	int PredictStepsToTarget();

public:
	Point posToReachBall;
	void PredictNextVel(float &DashPower);
protected:
	float RecommDashPower(bool fast) const;
	void PredictStamina();

public:	
	bool IsInMyKickArea(const Point& p);
	float effort;
	float stamina;
	float recovery;
	int   nStepsToReachBall;
};

#endif // PLAYER_WORLD_SIM_PLAYER_H
